jjb: disable Ubuntu-hwe-4.18.0 branch for bionic builds
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
5a196804 1#!/bin/bash -exu
f3d8604b 2#
1d5a0a3c 3# Copyright (C) 2016-2019 - Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
39961776
MJ
18# Parameters
19arch=${arch:-}
20cross_arch=${cross_arch:-}
21ktag=${ktag:-}
5a196804
MJ
22kgitrepo=${kgitrepo:-}
23mversion=${mversion:-}
24mgitrepo=${mgitrepo:-}
39961776
MJ
25
26
339db64d
MJ
27## FUNCTIONS ##
28
f3d8604b
MJ
29# Kernel version compare functions
30verlte() {
51fa2ab3 31 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
32}
33
34verlt() {
51fa2ab3 35 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
36}
37
38vergte() {
51fa2ab3 39 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
40}
41
42vergt() {
51fa2ab3 43 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
44}
45
339db64d 46
5a196804
MJ
47git_clone_modules_sources() {
48 mkdir -p "$MODULES_GIT_DIR"
49 git clone --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
50}
51
52# Checkout a shallow kernel tree of the specified tag
53git_clone_linux_sources() {
54 mkdir -p "$LINUX_GIT_DIR"
55 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
56}
7e02032c 57
7e02032c 58
5a196804
MJ
59# Export the kernel sources from the git repo
60git_export_linux_sources() {
61 cd "$LINUX_GIT_DIR"
62 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
63}
64
65
66# Upload the tar archive to the object store
67upload_archive_obj() {
68 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
69 rm -f "$WORKSPACE/$obj_name"
70}
71
72
73extract_archive_obj() {
74 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
75 rm -f "$WORKSPACE/$obj_name"
76}
77
78
79tar_archive_obj() {
80 cd "$LINUX_OBJ_DIR"
81 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
82 cd -
83}
84
85# Find the most recent GCC version supported by the kernel sources
86select_compiler() {
87 local selected_cc
88
89 cd "$LINUX_SRCOBJ_DIR"
90
91 kversion=$(make -s kernelversion)
92
93 set +e
94
1d5a0a3c 95 for cc in gcc-5 gcc-4.8; do
5a196804
MJ
96 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
97 selected_cc="$cc"
98 break
99 fi
100 done
101
102 set -e
103
104 if [ "x$selected_cc" = "x" ]; then
105 echo "Found no suitable compiler."
106 exit 1
107 fi
108
1d5a0a3c
MJ
109 # Force gcc-4.8 for kernels before 3.18
110 if { verlt "$kversion" "3.18"; }; then
23db2292 111 selected_cc=gcc-4.8
7e02032c
MJ
112 fi
113
425e4992
MJ
114 if [ "$selected_cc" != "gcc-4.8" ]; then
115 # Older kernel Makefiles do not expect the compiler to default to PIE
116 KAFLAGS="-fno-pie"
117 KCFLAGS="-fno-pie -no-pie"
118 KCPPFLAGS="-fno-pie"
119 export KAFLAGS KCFLAGS KCPPFLAGS
120 fi
121
5a196804 122 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 123 export HOSTCC="${selected_cc}"
5a196804
MJ
124
125 cd -
126}
127
128
129build_linux_kernel() {
130 cd "$LINUX_SRCOBJ_DIR"
131
132 kversion=$(make -s kernelversion)
133
7e02032c 134 # Generate kernel configuration
a1ae361e 135 case "$ktag" in
7e02032c 136 Ubuntu*)
39961776 137 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 138 if vergte "${kversion}" "4.10"; then
39961776
MJ
139 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
140 exit 0
141 fi
142 fi
a46abb0a
MJ
143 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
144 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 145 cp CONFIGS/"${ubuntu_config}" .config
7e02032c
MJ
146 ;;
147 *)
16844a6d
MJ
148 # Force 32bit build on i386, default is 64bit
149 if [ "$arch" = "i386" ]; then
5a196804
MJ
150 export ARCH="i386"
151 fi
152
153 # allyesconfig is mostly broken for kernels of the 2.6 series
154 if verlt "$kversion" "3.0"; then
155 vanilla_config="defconfig"
7a76a4d0
MJ
156 fi
157
5a196804 158 make "${vanilla_config}"
7e02032c
MJ
159 ;;
160 esac
161
5a196804
MJ
162 # silentoldconfig was renamed in 4.19
163 if vergte "$kversion" "4.19"; then
164 update_conf_target="syncconfig"
165 else
166 update_conf_target="silentoldconfig"
167 fi
168
169 # Fix 'defined(@array)' was removed from recent perl
170 if [ -f "kernel/timeconst.pl" ]; then
171 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
172 fi
173
174 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
23db2292 175 if [ "$CC" != "gcc-4.8" ]; then
5a196804
MJ
176 if [ -f "arch/x86/kvm/svm.c" ]; then
177 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
178 fi
179
180 if [ -f "arch/x86/kvm/vmx.c" ]; then
181 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
182 fi
183 fi
184
185 # Fix a typo in v2.6.36.x
186 if [ -f "arch/x86/kernel/entry_64.S" ]; then
187 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
188 fi
189
190 # Fix kernel < 3.0 with gcc >= 4.7
191 if verlt "$kversion" "3.0"; then
192 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
193 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
194 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
195 echo "header-y += linkage.h" >> include/linux/Kbuild
196 fi
197
7e02032c 198 # GCC 4.8
5a196804 199 sed -i "s/CONFIG_CC_STACKPROTECTOR_STRONG=y/# CONFIG_CC_STACKPROTECTOR_STRONG is not set/g" .config
7e02032c
MJ
200
201 # Don't try to sign modules
5a196804 202 sed -i "s/CONFIG_MODULE_SIG=y/# CONFIG_MODULE_SIG is not set/g" .config
7e02032c 203
9ef18fa2 204 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
5a196804
MJ
205 sed -i "s/CONFIG_STACK_VALIDATION=y/# CONFIG_STACK_VALIDATION is not set/g" .config
206
207 # Cause problems with inline assembly on i386
208 sed -i "s/CONFIG_DEBUG_SECTION_MISMATCH=y/# CONFIG_DEBUG_SECTION_MISMATCH is not set/g" .config
209
1d5a0a3c
MJ
210 # Don't build samples, they are broken on some kernel releases
211 sed -i "s/CONFIG_SAMPLES=y/# CONFIG_SAMPLES is not set/g" .config
212
5a196804
MJ
213 # IGBVF won't build with recent gcc on 2.6.38.x
214 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
215 sed -i "s/CONFIG_IGBVF=y/# CONFIG_IGBVF is not set/g" .config
216 fi
9ef18fa2 217
51fa2ab3
MJ
218 # Set required options
219 {
220 echo "CONFIG_KPROBES=y";
221 echo "CONFIG_FTRACE=y";
222 echo "CONFIG_BLK_DEV_IO_TRACE=y";
223 echo "CONFIG_TRACEPOINTS=y";
224 echo "CONFIG_KALLSYMS_ALL=y";
5a196804 225 } >> .config
7e02032c 226
7a76a4d0 227 # Debug
5a196804
MJ
228 #cat .config
229
230 make "$update_conf_target" CC="$CC"
231 make -j"$NPROC" CC="$CC"
232
233 krelease=$(make -s kernelrelease)
234
235 # Save the kernel and modules
236 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
237 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install
238 make INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install
239 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
240 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
241 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
242}
243
244
245extract_distro_headers() {
246
247 # Enter linux source dir
248 cd "${LINUX_SRCOBJ_DIR}"
249
250
251 # For RT kernels, copy version file
252 if [ -s localversion-rt ]; then
253 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
254 fi
255
256 # Copy all Makefile related stuff
257 find . -path './include/*' -prune \
258 -o -path './scripts/*' -prune -o -type f \
259 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
260 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
261 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
262
263 # Copy base scripts and include dirs
264 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 265
5a196804
MJ
266 # Copy arch includes
267 (find arch -name include -type d -print0 | \
268 xargs -0 -n1 -i: find : -type f) | \
269 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
270
271 # Copy arch scripts
272 (find arch -name scripts -type d -print0 | \
273 xargs -0 -n1 -i: find : -type f) | \
274 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
275
276 # Cleanup scripts
277 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
278 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
279
280 # On powerpc this object is required to link modules
281 if [ "${karch}" = "powerpc" ]; then
282 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
283 fi
284
285 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
286 if [ "${karch}" = "arm64" ]; then
287 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
288 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
289 fi
290 fi
291
292 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
293 if [ -f tools/objtool/objtool ]; then
294 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
295 fi
296
297 if [ -f "arch/x86/kernel/macros.s" ]; then
298 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
299 fi
300
301 # Copy modules related stuff, if available
302 if [ -s Module.symvers ]; then
303 cp Module.symvers "${LINUX_HDROBJ_DIR}"
304 fi
305
306 if [ -s System.map ]; then
307 cp System.map "${LINUX_HDROBJ_DIR}"
308 fi
309
310 if [ -s Module.markers ]; then
311 cp Module.markers "${LINUX_HDROBJ_DIR}"
312 fi
313
314 # Copy config file
315 cp .config "${LINUX_HDROBJ_DIR}"
316
317 # Make sure the Makefile and version.h have a matching timestamp so that
318 # external modules can be built
319 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
320 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
321 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
322 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
323 else
324 echo "Missing version.h"
325 exit 1
326 fi
327 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
328
329 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
330 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
331
332 # Finally clean the object files from the full source tree
333 make clean
334
335 # And regen the modules support files
336 make modules_prepare CC="$CC"
51fa2ab3 337
d815b018
MJ
338 # On powerpc this object is required to link modules
339 if [ "${karch}" = "powerpc" ]; then
5a196804 340 make arch/powerpc/lib/crtsavres.o CC="$CC"
d815b018
MJ
341 fi
342
7a76a4d0 343 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 344 if [ "${karch}" = "arm64" ]; then
c236528e 345 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 346 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
347 fi
348 fi
349
7e02032c 350 # Version specific tasks
a1ae361e 351 case "$ktag" in
7e02032c
MJ
352 Ubuntu*)
353 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 354 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
355 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
356 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
357 ;;
358 esac
7e02032c
MJ
359}
360
361
339db64d
MJ
362build_modules() {
363
5a196804
MJ
364 local kdir="$1"
365 local outdir="$2"
366 local kversion
367
368 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 369
339db64d 370 # Enter lttng-modules source dir
5a196804 371 cd "${MODULES_GIT_DIR}"
339db64d
MJ
372
373 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
374 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
375 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
376 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
377
378 set +e
379
380 # Build modules
51fa2ab3 381 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d 382
5a196804
MJ
383 set -e
384
339db64d
MJ
385 # We expect this build to fail, if it doesn't, fail the job.
386 if [ "$?" -eq 0 ]; then
e9b44189 387 echo "This build should have failed."
339db64d
MJ
388 exit 1
389 fi
390
391 # We have to publish at least one file or the build will fail
5a196804 392 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d
MJ
393
394 set -e
395
5a196804 396 KERNELDIR="${kdir}" make clean
7e02032c 397
339db64d
MJ
398 else # Regular build
399
400 # Build modules against full kernel sources
51fa2ab3 401 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
402
403 # Install modules to build dir
5a196804 404 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
405
406 # Clean build dir
5a196804 407 KERNELDIR="${kdir}" make clean
339db64d
MJ
408 fi
409}
410
411
412## MAIN ##
413
f3d8604b
MJ
414# Use all CPU cores
415NPROC=$(nproc)
416
5a196804
MJ
417MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
418LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 419
5a196804
MJ
420LINUX_OBJ_DIR="${WORKSPACE}/linux"
421LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
422LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
423LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 424
5a196804
MJ
425MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
426MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 427
5a196804
MJ
428LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
429
430OBJ_STORE_URL="s3://jenkins"
431
432cd "$WORKSPACE"
433
434# Create build directories
435mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
436
437git_clone_modules_sources
339db64d 438
7e02032c 439# Setup cross compile env if available
39961776 440if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
441
442 case "$cross_arch" in
443 "armhf")
444 karch="arm"
445 cross_compile="arm-linux-gnueabihf-"
e9b44189 446 vanilla_config="allyesconfig"
7e02032c
MJ
447 ubuntu_config="armhf-config.flavour.generic"
448 ;;
449
450 "arm64")
451 karch="arm64"
452 cross_compile="aarch64-linux-gnu-"
e9b44189 453 vanilla_config="allyesconfig"
7e02032c
MJ
454 ubuntu_config="arm64-config.flavour.generic"
455 ;;
456
457 "powerpc")
458 karch="powerpc"
459 cross_compile="powerpc-linux-gnu-"
e9b44189 460 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
461 ubuntu_config="powerpc-config.flavour.powerpc-smp"
462 ;;
463
464 "ppc64el")
465 karch="powerpc"
466 cross_compile="powerpc64le-linux-gnu-"
e9b44189 467 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
468 ubuntu_config="ppc64el-config.flavour.generic"
469 ;;
470
471 *)
51fa2ab3 472 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
473 exit 1
474 ;;
475 esac
339db64d 476
7e02032c
MJ
477 # Export variables used by Kbuild for cross compilation
478 export ARCH="${karch}"
479 export CROSS_COMPILE="${cross_compile}"
339db64d 480
7e02032c 481# Set arch specific values if we are not cross compiling
39961776 482elif [ "x${arch}" != "x" ]; then
e9b44189 483
7e02032c 484 case "$arch" in
16844a6d 485 "i386")
7e02032c 486 karch="x86"
e9b44189 487 vanilla_config="allyesconfig"
7e02032c
MJ
488 ubuntu_config="i386-config.flavour.generic"
489 ;;
490
16844a6d 491 "amd64")
7e02032c 492 karch="x86"
e9b44189 493 vanilla_config="allyesconfig"
7e02032c
MJ
494 ubuntu_config="amd64-config.flavour.generic"
495 ;;
496
497 "armhf")
498 karch="arm"
e9b44189 499 vanilla_config="allyesconfig"
7e02032c
MJ
500 ubuntu_config="armhf-config.flavour.generic"
501 ;;
502
503 "arm64")
504 karch="arm64"
e9b44189 505 vanilla_config="allyesconfig"
7e02032c
MJ
506 ubuntu_config="arm64-config.flavour.generic"
507 ;;
508
509 "powerpc")
510 karch="powerpc"
e9b44189 511 vanilla_config="allyesconfig"
7e02032c
MJ
512 ubuntu_config="powerpc-config.flavour.powerpc-smp"
513 ;;
514
515 "ppc64el")
516 karch="powerpc"
e9b44189 517 vanilla_config="allyesconfig"
7e02032c
MJ
518 ubuntu_config="ppc64el-config.flavour.generic"
519 ;;
520
521 *)
522 echo "Unsupported arch $arch"
523 exit 1
524 ;;
525 esac
526else
527 echo "Not arch or cross_arch specified"
528 exit 1
529fi
339db64d 530
339db64d 531
b214d997 532
5a196804
MJ
533# First get the kernel build from the object store, or build it, if it's
534# not available.
339db64d 535
5a196804
MJ
536echo "# Setup endpoint
537host_base = obj.internal.efficios.com
538host_bucket = obj.internal.efficios.com
539bucket_location = us-east-1
540use_https = True
7e02032c 541
5a196804
MJ
542# Setup access keys
543access_key = jenkins
544secret_key = echo123456
339db64d 545
5a196804
MJ
546# Enable S3 v4 signature APIs
547signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 548
5a196804
MJ
549url_hash="$(echo -n "$kgitrepo/$ktag/$arch/$cross_arch" | md5sum | awk '{ print $1 }')"
550obj_name="linux.tar.bz2"
551obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash"
552obj_url="$obj_url_prefix/$obj_name"
339db64d 553
5a196804
MJ
554set +e
555s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
556ret=$?
557set -e
339db64d 558
5a196804
MJ
559case "$ret" in
560 "0")
561 extract_archive_obj
562 ;;
a1ae361e 563
5a196804
MJ
564 "12")
565 echo "File not found"
339db64d 566
5a196804
MJ
567 # Build all the things and upload
568 # then finish the module build...
339db64d 569
5a196804
MJ
570 git_clone_linux_sources
571 git_export_linux_sources
339db64d 572
5a196804 573 select_compiler
a1ae361e 574
5a196804
MJ
575 ## PREPARE FULL LINUX SOURCE TREE
576 build_linux_kernel
d138fc44 577
5a196804
MJ
578 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
579 extract_distro_headers
339db64d 580
5a196804 581 tar_archive_obj
339db64d 582
5a196804 583 upload_archive_obj
339db64d 584
5a196804 585 ;;
339db64d 586
5a196804
MJ
587 *)
588 echo "Unknown error? Abort"
589 exit 1
590 ;;
591esac
339db64d 592
5a196804 593select_compiler
f3d8604b 594
7e02032c 595## BUILD modules
5a196804
MJ
596# Either we downloaded a pre-build kernel or we built it and uploaded
597# the archive for future builds.
598
599cd "$WORKSPACE"
f3d8604b 600
339db64d 601# Build modules against full kernel sources
5a196804 602build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 603
339db64d 604# Build modules against kernel headers
5a196804 605build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 606
5a196804
MJ
607# Make sure some modules were actually built
608tree "${MODULES_OUTPUT_KSRC_DIR}"
609if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
610 echo "No modules built!"
611 exit 1
612fi
613
5a196804
MJ
614tree "${MODULES_OUTPUT_KHDR_DIR}"
615if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
616 echo "No modules built!"
617 exit 1
618fi
b214d997 619
f3d8604b 620# EOF
This page took 0.072647 seconds and 4 git commands to generate.